routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::redirect('/', config('app.url') . '/home');
Route::view('/home', '/frontend/home');

/* Test Route (for dev purposes) */
//Route::get('/tests', [ 'uses' =>'PlasmidBaseController@index', 'as' => 'plasmid.map' ]);

Route::group([], __DIR__.'/web/frontend.php');

/* Voyager routes */
Route::group(['prefix' => 'admin'], function () {
    Voyager::routes();

    Route::group([], __DIR__.'/web/csv.php');

    // MyLabStocks overriding routes here
    $namespacePrefix = '\\'.config('voyager.controllers.namespace').'\\';
    try {
            foreach (Voyager::model('DataType')::all() as $dataType) {
                $breadController = $dataType->controller
                                 ? Str::start($dataType->controller, '\\')
                                 : $namespacePrefix.'VoyagerBaseController';

                Route::get($dataType->slug.'/{id}/duplicate', ['uses' => $breadController.'@duplicate', 'as' => 'voyager.'.$dataType->slug.'.duplicate']);
                //Route::get('search/'.$dataType->slug   , ['uses' => $breadController.'@search', 'as' => 'voyager.search.'.$dataType->slug]);
            }
        } catch (\InvalidArgumentException $e) {
            throw new \InvalidArgumentException("Custom routes hasn't been configured because: ".$e->getMessage(), 1);
        } catch (\Exception $e) {
            // do nothing, might just be because table not yet migrated.
        }
});

/* BLAST routes */
Route::get('/blast/',  [ 'uses' => 'BlastController@welcome', 'as' => 'blast.welcome' ]);
Route::post('/blast/', [ 'uses' => 'BlastController@search' , 'as' => 'blast.search'  ]);
Route::get('/updateBlastDnaFeatures', [ 'uses' =>'BlastController@update_dna_features', 'as' => 'update_blast_dna_features' ]);

/* Route to update plasmid sequence from its .gb file */
Route::get('/sequence/updateplasmid/{id}', [ 'uses' =>'PlasmidSequenceController@update_plasmid_seq_from_file', 'as' => 'sequence.update_plasmid_seq_from_file' ]);

app/Strain.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Strain extends Model
{
    use HasFactory;

    /**
     * Relationship to select the author of this strain.
     */
    public function author()
    {
        return $this->belongsTo('App\User');
    }

    /**
     * Relationship to get the species of this strain.
     */
    public function species()
    {
        return $this->belongsTo('App\Specie');
    }

    /**
     * Relationship to get the general background of this strain.
     */
    public function generalBackground()
    {
        return $this->belongsTo('App\Background');
    }

    /**
    * Relationship to get the mating type of this strain.
    */
    public function matingType()
    {
        return $this->belongsTo('App\Yeast\StMat');
    }

    /**
    * Relationships to get the auxotrophies of this strain.
    */
    public function ade2(){return $this->belongsTo('App\Yeast\StAde2');}
    public function his3(){return $this->belongsTo('App\Yeast\StHis3');}
    public function leu2(){return $this->belongsTo('App\Yeast\StLeu2');}
    public function lys2(){return $this->belongsTo('App\Yeast\StLys2');}
    public function met15(){return $this->belongsTo('App\Yeast\StMet15');}
    public function trp1(){return $this->belongsTo('App\Yeast\StTrp1');}
    public function ura3(){return $this->belongsTo('App\Yeast\StUra3');}

    public function getGenotypeAttribute()
    {
        $gen = collect([
            $this->mating_type,
            $this->ade2,
            $this->his3,
            $this->leu2,
            $this->lys2,
            $this->met15,
            $this->trp1,
            $this->ura3,
            $this->ho,
            $this->locus1,
            $this->locus2,
            $this->locus3,
            $this->locus4,
            $this->locus5
        ]);

        return sprintf('%s [ %s ] ( %s )', $gen->implode(' '), $this->cytoplasmic_character, $this->extrachromosomal_plasmid);
    }

}

app/Http/Controllers/Frontend/AntibodyController.php
<?php

namespace App\Http\Controllers\Frontend;

use App\Antibody;
use App\DataType;
use App\Http\Controllers\Controller;
use App\Traits\Frontend\SearchBuilder;
use Carbon\Exceptions\ParseErrorException;
use Illuminate\Support\Carbon;
use Yajra\DataTables\DataTables;
use Yajra\DataTables\Html\Builder;

class AntibodyController extends Controller
{
    use SearchBuilder;

    public function index(Builder $builder)
    {
        $this->authorize('browse_antibodies');

        $dataType = DataType::query()
            ->with(['dataRows' => function ($query) {
                $query->where('browse', '=', true)
                    ->where('type', '!=', 'relationship');
            }])
            ->where('model_name', '=', 'App\Antibody')
            ->firstOrFail();

        if (request()->ajax()) {
            $query = Antibody::query()->when(request()->searchBuilder, function ($query, $searchBuilderAjaxRequest) {
                $criteria = $searchBuilderAjaxRequest['criteria'];
                $logic = $searchBuilderAjaxRequest['logic'];
                $query = $this->buildRecursiveQuery($query, $criteria, $logic);
            });

            // Init datatables
            $dataTables = DataTables::of($query)
                ->addColumn('created_at', function (Antibody $antibody) {
                    if ($antibody->created_at) {
                        try {
                            $createdAt = Carbon::parse($antibody->created_at);
                        } catch (ParseErrorException $e) {
                            return '';
                        }
                        return sprintf('<time datetime="%s">%s</time>', $createdAt->toDateString(), $createdAt->isoFormat('ll'));
                    }
                })
                ->addColumn('obtention_date', function (Antibody $antibody) {
                    if ($antibody->obtention_date) {
                        try {
                            $obtentionDate = Carbon::parse($antibody->obtention_date);
                        } catch (ParseErrorException $e) {
                            return '';
                        }
                        return sprintf('<time datetime="%s">%s</time>', $obtentionDate->toDateString(), $obtentionDate->isoFormat('ll'));
                    }
                })
                ->addColumn('actions', function (Antibody $antibody) {
                    $actions = [];
                    if (auth()->user()->can('read', $antibody)) {
                        $actions[] = sprintf('<a href="%s" target="_blank" class="text-secondary">View</a>', route('voyager.antibodies.show', ['id' => $antibody]));
                    }
                    if (auth()->user()->can('edit', $antibody)) {
                        $actions[] = sprintf('<a href="%s" target="_blank" class="text-secondary">Edit</a>', route('voyager.antibodies.edit', ['id' => $antibody]));
                    }
                    if (auth()->user()->can('add', $antibody)) {
                        $actions[] = sprintf('<a href="%s" target="_blank" class="text-secondary">Duplicate</a>', route('voyager.antibodies.duplicate', ['id' => $antibody]));
                    }
                    return implode(' ', $actions);
                })
                ->rawColumns(['actions', 'created_at', 'obtention_date']);

            // Enable column search
            foreach ($dataType->dataRows as $dataRow) {
                $dataTables->filterColumn($dataRow->field, function ($query, $keyword) use ($dataRow) {
                    $query->where($dataRow->field, 'like', '%' . $keyword . '%');
                });
            }

            // Execute
            return $dataTables->toJson();
        }

        // HTML Builder parameters
        // Action column is placed first
        $builder->addColumn([
            'data' => 'actions',
            'name' => 'actions',
            'title' => 'Actions',
            'sortable' => false,
            'searchable' => false
        ]);

        // Remaining columns
        foreach($dataType->dataRows as $dataRow) {
            $builder->addColumn([
                'data' => $dataRow->field,
                'name' => $dataRow->field,
                'title' => $dataRow->display_name
            ]);
        }

        // Remove "actions" from DataTable SearchBuilder column dropdown
        $searchBuilderColumns = $builder->getColumns()->reject(function($item, $key) {
            return $item['name'] == 'actions';
        })->keys()->toArray();

        // Datatables JS parameters
        $builder->parameters([
            'paging' => true,
            'searching' => true,
            'info' => false,
            'searchDelay' => 350,
            'scrollY' => '428px',
            'scrollX' => true,
            'scrollCollapse' => true,
            'initComplete' => "function () {
                i = 0;
                this.api().columns().every(function () {
                    var column = this;
                    if (i > 0) {
                        var input = document.createElement(\"input\");
                        $(input)
                            .appendTo($(column.footer()).empty())
                            .addClass('form-control')
                            .on('keyup', function () {
                                column.search($(this).val(), false, false, true).draw();
                            });
                    } else {
                        var label = document.createElement(\"label\");
                        $(label)
                            .appendTo($(column.footer()).empty())
                            .text('Search');
                    }
                    i++;
                });
            }",
            'dom' => 'Qlfrtip',
            'searchBuilder' => [
                'depthLimit' => false,
                'columns' => $searchBuilderColumns,
            ],
            'deferRender' => true,
        ]);

        return view('frontend.antibodies.index', compact('builder', 'dataType'));
    }
}

app/Http/Controllers/Frontend/OligoController.php
<?php

namespace App\Http\Controllers\Frontend;

use App\DataType;
use App\Http\Controllers\Controller;
use App\Traits\Frontend\SearchBuilder;
use App\Traits\Frontend\VoyagerRelationships;
use App\Oligo;
use Carbon\Exceptions\ParseErrorException;
use Illuminate\Support\Carbon;
use Yajra\DataTables\DataTables;
use Yajra\DataTables\Html\Builder;

class OligoController extends Controller
{
    use VoyagerRelationships;
    use SearchBuilder;

    public function index(Builder $builder)
    {
        $this->authorize('browse_oligos');

        $dataType = DataType::query()
            ->with(['dataRows' => function ($query) {
                $query->where('browse', '=', true)
                    ->where('type', '!=', 'relationship');
            }])
            ->where('model_name', '=', 'App\Oligo')
            ->firstOrFail();

        if (request()->ajax()) {
            $query = Oligo::query()->when(request()->searchBuilder, function ($query, $searchBuilderAjaxRequest) {
                $criteria = $searchBuilderAjaxRequest['criteria'];
                $logic = $searchBuilderAjaxRequest['logic'];
                $query = $this->buildRecursiveQuery($query, $criteria, $logic);
            });

            // Init datatables
            $dataTables = DataTables::of($query)
                ->addColumn('created_at', function (Oligo $oligo) {
                    if ($oligo->created_at) {
                        try {
                            $createdAt = Carbon::parse($oligo->created_at);
                        } catch (ParseErrorException $e) {
                            return '';
                        }
                        return sprintf('<time datetime="%s">%s</time>', $createdAt->toDateString(), $createdAt->isoFormat('ll'));
                    }
                })
                ->addColumn('obtention_date', function (Oligo $oligo) {
                    if ($oligo->obtention_date) {
                        try {
                            $obtentionDate = Carbon::parse($oligo->obtention_date);
                        } catch (ParseErrorException $e) {
                            return '';
                        }
                        return sprintf('<time datetime="%s">%s</time>', $obtentionDate->toDateString(), $obtentionDate->isoFormat('ll'));
                    }
                })
                ->addColumn('actions', function (Oligo $oligo) {
                    $actions = [];
                    if (auth()->user()->can('read', $oligo)) {
                        $actions[] = sprintf('<input id="oligo-%d" name="oligo-%d" value="%s" type="text" class="w-25" readonly/>', $oligo->id, $oligo->id, $oligo->sequence);
                        $actions[] = sprintf('<a href="#" onclick="document.getElementById(\'oligo-%d\').select(); document.execCommand(\'copy\'); toastr.info(\'Sequence copied to clipboard\')">CopySeq</a>', $oligo->id);
                        $actions[] = sprintf('<a href="%s" target="_self">View</a>', route('frontend.oligos.show', ['oligo' => $oligo]));
                    }
                    if (auth()->user()->can('edit', $oligo)) {
                        $actions[] = sprintf('<a href="%s" target="_blank" class="text-secondary">Edit</a>', route('voyager.oligos.edit', ['id' => $oligo]));
                    }
                    if (auth()->user()->can('add', $oligo)) {
                        $actions[] = sprintf('<a href="%s" target="_blank" class="text-secondary">Duplicate</a>', route('voyager.oligos.duplicate', ['id' => $oligo]));
                    }
                    return implode(' ', $actions);
                })
                ->rawColumns(['actions', 'created_at', 'obtention_date', 'description']);

            // Enable column search
            foreach ($dataType->dataRows as $dataRow) {
                $dataTables->filterColumn($dataRow->field, function ($query, $keyword) use ($dataRow) {
                    $query->where($dataRow->field, 'like', '%' . $keyword . '%');
                });
            }

            // Execute
            return $dataTables->toJson();
        }

        // HTML Builder parameters
        // Action column is placed first
        $builder->addColumn([
            'data' => 'actions',
            'name' => 'actions',
            'title' => 'Actions',
            'sortable' => false,
            'searchable' => false
        ]);

        // Remaining columns
        foreach($dataType->dataRows as $dataRow) {
            $builder->addColumn([
                'data' => $dataRow->field,
                'name' => $dataRow->field,
                'title' => $dataRow->display_name
            ]);
        }

        // Remove "actions" from DataTable SearchBuilder column dropdown
        $searchBuilderColumns = $builder->getColumns()->reject(function($item, $key) {
            return $item['name'] == 'actions';
        })->keys()->toArray();

        // Datatables JS parameters
        $builder->parameters([
            'paging' => true,
            'searching' => true,
            'info' => false,
            'searchDelay' => 350,
            'scrollY' => '428px',
            'scrollX' => true,
            'scrollCollapse' => true,
            'initComplete' => "function () {
                i = 0;
                this.api().columns().every(function () {
                    var column = this;
                    if (i > 0) {
                        var input = document.createElement(\"input\");
                        $(input)
                            .appendTo($(column.footer()).empty())
                            .addClass('form-control')
                            .on('keyup', function () {
                                column.search($(this).val(), false, false, true).draw();
                            });
                    } else {
                        var label = document.createElement(\"label\");
                        $(label)
                            .appendTo($(column.footer()).empty())
                            .text('Search');
                    }
                    i++;
                });
            }",
            'dom' => 'Qlfrtip',
            'searchBuilder' => [
                'depthLimit' => false,
                'columns' => $searchBuilderColumns,
            ],
            'deferRender' => true,
        ]);

        return view('frontend.oligos.index', compact('builder', 'dataType'));
    }

    public function show(Oligo $oligo)
    {
        $this->authorize('read', $oligo);

        $dataType = DataType::query()
            ->with(['dataRows' => function ($query) {
                $query->where('read', '=', true);
            }])
            ->where('model_name', '=', 'App\Oligo')
            ->firstOrFail();

        $this->resolveRelations($dataType);

        return view('frontend.oligos.show', [
            'dataType' => $dataType,
            'item' => $oligo
        ]);
    }
}

resources/views/frontend/strains/index.blade.php
@extends('frontend.layout')

@section('content')
    <div class="container mt-4 mb-4">
        <div class="d-flex justify-content-between mb-2">
            <h2>{{ $dataType->display_name_plural }}</h2>
            <div>
                <a href="{{ route(sprintf('voyager.%s.create', $dataType->slug)) }}" target="_blank" class="btn btn-secondary">{{ __('Add') }}</a>
            </div>
        </div>

        {!! $builder->table(['class' => 'table table-striped table-bordered'], true) !!}

    </div>
@endsection

@push('scripts')
    {!! $builder->scripts() !!}
@endpush

resources/views/frontend/strains/show.blade.php
@extends('frontend.layout')

@section('content')
    <div class="container mt-4 mb-4">
        <div class="d-flex justify-content-between mb-2">
            <h2>{{ $dataType->display_name_singular }} {{ $item->name }}</h2>
            <div>
                <a href="{{ route(sprintf('voyager.%s.edit', $dataType->slug), ['id' => $item->id]) }}" target="_blank" class="btn btn-secondary">{{ __('Edit') }}</a>
            </div>
        </div>

        <div class="row row-cols-1 row-cols-sm-2 row-cols-md-2 g-3">
            <div class="col-12 col-sm-6 col-md-3">
                @if($item->warning)
                    <div class="alert alert-danger" role="alert">
                        Issue! See comments
                    </div>
                @else
                    <div class="alert alert-info" role="alert">
                        No issue detected.
                    </div>
                @endif
                <div class="card">
                    <ul class="list-group list-group-flush">
                        <li class="list-group-item">
                            <div class="row">
                                <div class="col">
                                    Strain
                                </div>
                                <div class="col">
                                    {{ $item->id }}
                                </div>
                            </div>
                        </li>
                        <li class="list-group-item">
                            <div class="row">
                                <div class="col">
                                    Name
                                </div>
                                <div class="col">
                                    {{ $item->name }}
                                </div>
                            </div>
                        </li>
                        <li class="list-group-item">
                            <div class="row">
                                <div class="col">
                                    Species
                                </div>
                                <div class="col">
                                    {{ $item->species }}
                                </div>
                            </div>
                        </li>
                        <li class="list-group-item">
                            <div class="row">
                                <div class="col">
                                    Background
                                </div>
                                <div class="col">
                                    {{ $item->general_background }}
                                </div>
                            </div>
                        </li>
                        <li class="list-group-item">
                            <div class="row">
                                <div class="col">
                                    Author
                                </div>
                                <div class="col">
                                    {{ $item->author }}
                                </div>
                            </div>
                        </li>
                        <li class="list-group-item">
                            <div class="row">
                                <div class="col">
                                    Projects
                                </div>
                                <div class="col">
                                    @if($item->projects)
                                        <ul class="list-group list-group-flush">
                                            @foreach($item->projects as $project)
                                                <li class="list-group-item">
                                                    <a href="{{ route('voyager.projects.show', ['id' => $project->id]) }}"
                                                       target="_blank">{{ $project->name }}</a>
                                                </li>
                                            @endforeach
                                        </ul>
                                    @endif
                                </div>
                            </div>
                        </li>
                    </ul>

                    <div class="card-body">
                        <a href="{{ route(sprintf('voyager.%s.show', $dataType->slug), ['id' => $item->id]) }}"
                           target="_blank" class="card-link">View in Back-End</a>
                    </div>
                </div>
            </div>

            <div class="col-12 col-sm-6 col-md-9">
                <div class="card">
                    <div class="card-body">
                        <legend>Genotype</legend>
                        {!! $item->genotype !!}
                    </div>
                </div>
            </div>
        </div>

        @if($item->files)
            <div class="mt-3">
                <div class="card">
                    <div class="card-body">
                        <legend>Files</legend>
                        <x-frontend.data type="media_picker" :value="$item->files"/>
                    </div>
                </div>
            </div>
        @endif

        @if($item->comments)
            <div class="mt-3">
                <div class="card">
                    <div class="card-body">
                        <legend>Comments</legend>
                        {!! $item->comments !!}
                    </div>
                </div>
            </div>
        @endif

        @include('frontend.partials.dataType', ['dataType' => $dataType])

    </div>
@endsection